"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../index");
var error_1 = require("../error");
describe("test", function () {
    test("normal", function () {
        expect(index_1.binary([1, 2, 3])).toEqual({
            left: index_1.createTree(2),
            right: index_1.createTree(3),
            val: 1,
        });
        expect(index_1.binary([1, 2, 3, null, 4, 5, null])).toEqual({
            left: index_1.createTree(2, undefined, index_1.createTree(4)),
            right: index_1.createTree(3, index_1.createTree(5)),
            val: 1,
        });
        expect(index_1.binary([1, 2, 3, null, 4, null, null, 5, null, 6])).toEqual({
            left: index_1.createTree(2, undefined, index_1.createTree(4, index_1.createTree(5, index_1.createTree(6)))),
            right: index_1.createTree(3),
            val: 1,
        });
    });
    test("return undefined when input is empty array", function () {
        var node = index_1.binary([]);
        expect(node).toEqual(undefined);
    });
    test("throw error inputs element are too many", function () {
        var inputs = [1, 2, 3, null, null, null, null, 5];
        expect(function () {
            index_1.binary(inputs);
        }).toThrowError(error_1.createTooManyInputValues(inputs));
    });
});
