"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.binary = exports.createTree = void 0;
var error_1 = require("./error");
exports.createTree = function (val, left, right) {
    return {
        val: val,
        left: left,
        right: right,
    };
};
exports.binary = function (input) {
    if (input.length === 0)
        return;
    var dummy = exports.createTree(input.shift());
    var root = dummy;
    var baseStack = [root];
    var index = 0;
    while (index < input.length && 0 < baseStack.length) {
        var stack = [];
        while (0 < baseStack.length) {
            var node = baseStack.shift();
            var left = input[index++];
            var right = input[index++];
            if (left != null) {
                node.left = exports.createTree(left);
                stack.push(node.left);
            }
            if (right != null) {
                node.right = exports.createTree(right);
                stack.push(node.right);
            }
        }
        baseStack = stack;
    }
    if (index < input.length) {
        throw error_1.createTooManyInputValues(input.slice(index));
    }
    return dummy;
};
